#ifndef SUITE1_HPP
#define SUITE1_HPP
#include <cmath>
#include <iostream>

using namespace std;

class suite1 {
  int n;
  double * A;
  double * b;
  double * un;
  int indice_k(int i,int j){
    return i+j*n;
  }
  
public: 
  suite1 (){
    n = 0;
    A = NULL;
    b = NULL;
    un = NULL;
  }
  suite1 (int nn){
    n = nn;
    b = new double[nn];
    un = new double[nn];
    A = new double[nn*nn];
    for(int i =0; i<n;i++){
  	b[i] = 0.0;
	un[i] = 0.0;
	for(int j =0; j<n;j++){
	  A[indice_k(i,j)] = 0.0;
	}
    }
  }
  suite1 (const suite1 & x){
    n = x.n;

    if(x.b != NULL && x.un != NULL && x.A != NULL){
      b = new double[n];
      un = new double[n];
      A = new double[n*n];
      for(int i =0; i<n;i++){
  	b[i] = x.b[i];
	un[i] = x.un[i];
	for(int j =0; j<n;j++){
	  A[indice_k(i,j)] = x.A[indice_k(i,j)];
	}
      }
    }
  }
  ~suite1 (){
    if(b != NULL){
      delete [] b;
    }
    if(un != NULL){
      delete [] un;
    }
    if(A != NULL){
      delete [] A;
    }
  }
  suite1 & operator = (const suite1 &);
  suite1 operator + (const suite1 &);
  void set_bi(int, double);
  void set_Aij(int,int, double);
  void set_u0i(int, double);
  void set_bi(int, double * );
  void set_Aij(int,int, double *);
  void set_u0i(int, double *);
  void plot_un();
  void term_n(int);
}; 
#endif
